package com.americancoders.edi;

import java.util.*;

/**
 * class for all Data Elements defined as character and alphanumeric
 *
*<P>OBOE - Open Business Objects for EDI
 *<br>An EDI and XML Translator Written In Java 
 *<br>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
 *<br>All rights reserved
 *<br>American Coders, Ltd
 *<br>P. O. Box 97462
 *<br>Raleigh, NC  27624  USA
 *<br>1-919-846-2014
 *<br>http://www.americancoders.com
@author Joe McVerry, American Coders Ltd.
@version 1.4.1
*/

public class CharDE extends DataElement
 {


/**
 * constructs the CharDE type
 * @param String field id
 * @param int sequence number within structure
 * @param String Description
 * @param char required
 * @param int minimum allowed length
 * @param int maximum allowed length
 * @param String xml tag value
 *
*/

public CharDE(String inID, int inSequence, String inDesc, char inRequired, int inMinLength, int inMaxLength, String inXMLTag)
{
        super(inID, inSequence,  inDesc, inRequired, inMinLength, inMaxLength, inXMLTag);
}

/**
 * constructs the CharDE type
 * @param String field id
 * @param int sequence number within structure
 * @param String Description
 * @param char required
 * @param int minimum allowed length
 * @param int maximum allowed length
 *
*/

public CharDE(String inID, int inSequence, String inDesc, char inRequired, int inMinLength, int inMaxLength)
{
        super(inID, inSequence,  inDesc, inRequired, inMinLength, inMaxLength);
}
/**
 * constructs the Char DE type and sets its value
 * @param String input value
 * @param String fuekd UD
 * @param int sequence number within structure
 * @param String Description
 * @param char required
 * @param int minimum allowed length
 * @param int maximum allowed length
 * @param String xml tag value
 *
*/
public CharDE(String inValue, String inID, int inSequence, String inDesc, char inRequired, int inMinLength, int inMaxLength, String inXMLTag)
{
        super(inValue, inID, inSequence,  inDesc, inRequired, inMinLength, inMaxLength, inXMLTag);
}

/**
 * constructs the Char DE type and sets its value
 * @param String input value
 * @param int sequence number within structure
 * @param String Description
 * @param char required
 * @param int minimum allowed length
 * @param int maximum allowed length
 *
*/
public CharDE(String inValue, String inID, int inSequence, String inDesc, char inRequired, int inMinLength, int inMaxLength)
{
        super(inValue, inID, inSequence,  inDesc, inRequired, inMinLength, inMaxLength);
}

}
