package com.americancoders.edi.EDIFact;
/*
 * <p>EdifactExample.java
 * <p>Copyright 1999 mendelson-e-commerce GmbH Berlin Germany
 * <p>http://www.mendelson.de
 * <p>Created on 5. Januar 2000, 15:27
 * @author Stefan Heller
 */
 
import com.americancoders.edi.*;
import java.io.*;
import java.util.*;

/** 
 * @version 1.0 
 */
public class EdifactExample{
    
    public EdifactExample(String filein, String fileout) {
	try{
	    //receive file contents
	    com.americancoders.edi.EDIFact.Parser p = new
	        com.americancoders.edi.EDIFact.Parser(new File( filein ));
        TransactionSet transactionSet = p.getTransactionSet();
        System.out.println( "result written to \"" + fileout + "\"." );
		
		String outputString = transactionSet.getFormattedText(1);
		FileOutputStream fos = new FileOutputStream( new File( fileout ));
        byte[] buffer = outputString.getBytes();
        fos.write( buffer );
		fos.flush();
		fos.close();
	}
	catch( Exception e ){
	    System.out.println( e.getMessage() );
	    //e.printStackTrace();
	}
	
    }
    
    /**Reads the contents of a file and returns it as String - warning: there may occure
     * problems because a byte buffer is used instead of a char buffer.
     *@author S.Heller
     *@param inFile File to read
     *@param return String that contains the file contents
     */
    public String getContents( File inFile ) throws IOException{
	byte buffer[] = new byte[(int)inFile.length()];
	FileInputStream fis = new FileInputStream(inFile);
	fis.read(buffer);
	return( new String( buffer ));
    }
    
     /**
     * @param args the command line arguments
     */
    public static void main (String args[]) {
		if( args == null || args.length < 2 ){
			System.out.println( "usage: java EdifactExample <edidatafilename> <xmloutfilename>" );
			System.exit( -1 );
		}
		new EdifactExample(args[0], args[1]);
    }
    
}
