package com.americancoders.edi.EDIFact;

/**
 *OBOE - Open Business Objects for EDI 
 *<p>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
 *<p>All rights reserved
 *<p>American Coders, Ltd
 *<br>P. O. Box 97462
 *<br>Raleigh, NC  27624  USA
 *<br>1-919-846-2014
 *<br>http://www.americancoders.com
@author Joe McVerry, American Coders Ltd.
@version 1.4.1
*/


import java.util.*;
import com.americancoders.edi.*;
import com.americancoders.edi.Tokenizer.*;

/**
 * staticly defined class for EDIFact Segment   Functional_Group_Header
 *
*/
public class  Functional_Group_Header 
 {
    
  public static final String id = "UNG";
  
/** 
 * Factory method to create an Funcitonal Group Header
 * @return Segment Funcitonal Group Header
 * @exception Exceptions can be thrown
 */

  public static Segment getInstance()
     throws Exception
    {
       CompositeDE cde;
       Segment returnSeg = new Segment(id, 0, "Message Header", 1, 'M');
       returnSeg.addDataElement(new CharDE("0038", 1, "Functional Group Identification",'M', 1, 6)); 
             
       cde = new CompositeDE("S006", 2, "SenderID");
       returnSeg.addCompositeDE(cde);
       
       cde.addDataElement(new CharDE("0040", 1, "Sender ID",'M', 1, 35));
       cde.addDataElement(new CharDE("0007", 2, "Identifier Code Qualifier",'C', 1, 4 )); 
       
       cde = new CompositeDE("S007", 2, "ReceiverID");
       returnSeg.addCompositeDE(cde);
       cde.addDataElement(new CharDE("0044", 1, "Reciever ID",'M', 1, 35));
       cde.addDataElement(new CharDE("0007", 2, "Identifier Code Qualifier",'C', 1, 4 )); 
       
       
       cde = new CompositeDE("S004", 3, "DateTime");
       returnSeg.addCompositeDE(cde);
       cde.addDataElement(new DateDE("0017", 1,    "Date" , 'O', 6, 6));
       cde.addDataElement(new TimeDE("0019", 2,    "Time", 'O', 4, 4));
       
       returnSeg.addDataElement(new CharDE("0048", 4, "Group Reference Number",'M', 1, 14 ));
       returnSeg.addDataElement(new CharDE("0051", 5, "Controlling Agency",'M', 1, 2 ));
       
       cde = new CompositeDE("S008", 6, "MessageVersion");
       returnSeg.addCompositeDE(cde);
             
       returnSeg.addDataElement(new CharDE("0058", 7, "Application Password",'C', 1, 14));
             
             
       return returnSeg;
    }  
 }
