package com.americancoders.edi.EDIFact;

/**
 *OBOE - Open Business Objects for EDI 
 *<p>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
 *<p>All rights reserved
 *<p>American Coders, Ltd
 *<br>P. O. Box 97462
 *<br>Raleigh, NC  27624  USA
 *<br>1-919-846-2014
 *<br>http://www.americancoders.com
@author Joe McVerry, American Coders Ltd.
@version 1.4.1
*/


import java.util.*;
import com.americancoders.edi.*;
import com.americancoders.edi.Tokenizer.*;

/**
 * staticly defined class for EDIFact Segment   Interchange_Header
 *
*/
public class  Interchange_Header 
 {
    
  public static final String id = "UNB";
  
/** 
 * Factory method to create an Interchange Header
 * @return Segment Interchange Header
 * @exception Exceptions can be thrown
 */

  public static Segment getInstance()
     throws Exception
    {
       CompositeDE cde;
       Segment returnSeg = new Segment(id, 0, "Interchange Header", 1, 'M');
             
       cde = new CompositeDE("S001", 1, "SYNTAX_IDENTIFIER");
       returnSeg.addCompositeDE(cde);
       cde.addDataElement(new CharDE("0001", 1, "Syntax identifier", 'M', 4,4,
                    "syntaxId"));
       cde.addDataElement(new NumericDE("0002",  2, "Syntax version number", 'M', 1, 1, 
                    "syntaxVersion"));
       cde = new CompositeDE("S002", 2, "INTERCHANGESENDER");
       returnSeg.addCompositeDE(cde);
       cde.addDataElement(new CharDE("0004", 1, "Sender identification", 'M', 1, 35,
                   "senderId"));
       cde.addDataElement(new CharDE("0007", 2, "Partner identification", 'C', 1, 4,
                   "partnerID"));
       cde.addDataElement(new CharDE("0008", 3, "Address for reverse", 'C', 1, 14,
                   "addressForReverse"));


       cde = new CompositeDE("S003", 3, "INTERCHANGERECIPIENT");
       returnSeg.addCompositeDE(cde);
       cde.addDataElement(new CharDE("0010", 1, "Recipient Identification", 'M', 1, 35, 
                   "recipientId"));
       cde.addDataElement(new CharDE("0007", 2, "Partner identification" , 'C', 1, 4,
                   "partnerID"));
       cde.addDataElement(new CharDE("0014", 3, "Routing address", 'C', 1, 14,
                   "routingAddress"));
        
       cde = new CompositeDE("S004", 4, "DATETIMEOFPREPARATION");
       returnSeg.addCompositeDE(cde);
       cde.addDataElement(new DateDE("0017", 1,    "Date" , 'M', 6, 6,
                   "prepDate"));
       cde.addDataElement(new TimeDE("0019", 2,    "Time", 'M', 4, 4,
                   "prepTime"));

       returnSeg.addDataElement(new CharDE("0020" , 5, "INTERCHANGE CONTROL", 'M', 1, 14,
                   "ic"));
        
       cde = new CompositeDE("S005", 6, "RECIPIENTSREFERENCE");
       returnSeg.addCompositeDE(cde);
       cde.addDataElement(new CharDE("0022", 1, "Recipient's reference", 'M', 1, 14,
                    "recipientRefNumber"));
       cde.addDataElement(new CharDE("0025", 2, "Recipient's reference", 'C', 2, 2,
                    "recipientRefId"));
        
       returnSeg.addDataElement(new CharDE("0026", 7, "APPLICATION REFERENCE", 'C', 1, 14, 
                    "applicateionRef"));
       returnSeg.addDataElement(new CharDE("0029", 8, "PROCESSING PRIORITY CODE" , 'C', 1, 1,
                    "priority"));
       returnSeg.addDataElement(new NumericDE("0031", 9, "ACKNOWLEDGEMENT REQUEST", 'C', 1, 1,
                    "ackRequest"));
       returnSeg.addDataElement(new CharDE("0032",10, "COMMUNICATIONS AGREEMENT", 'C', 1, 35,
                    "commsAgreement"));
       returnSeg.addDataElement(new NumericDE("0035", 11, "TEST INDICATOR", 'C', 1, 1,
                    "testInd"));

        
       return returnSeg;
       
    }
 }
