package com.americancoders.edi.EDIFact;

/**
 *OBOE - Open Business Objects for EDI 
 *<p>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
 *<p>All rights reserved
 *<p>American Coders, Ltd
 *<br>P. O. Box 97462
 *<br>Raleigh, NC  27624  USA
 *<br>1-919-846-2014
 *<br>http://www.americancoders.com
@author Joe McVerry, American Coders Ltd.
@version 1.4.1
*/


import java.util.*;
import com.americancoders.edi.*;
import com.americancoders.edi.Tokenizer.*;

/**
 * staticly defined class for EDIFact Segment   Message_Header
 *
*/
public class  Message_Header 
 {
    
  public static final String id = "UNH";
  
/** 
 * Factory method to create an Message Header
 * @return Segment Message Header
 * @exception Exceptions can be thrown
 */

  public static Segment getInstance()
     throws Exception
    {
       CompositeDE cde;
       Segment returnSeg = new Segment(id, 0, "Message Header", 1, 'M');
       returnSeg.addDataElement(new CharDE("0062", 1, "Message reference number",'O', 1, 14, 
             "messageReferenceNumber"));
             
       cde = new CompositeDE("S009", 2, "messageIdentifier");
       returnSeg.addCompositeDE(cde);
       
       cde.addDataElement(new CharDE("0065", 1, "Message type identifier",'O', 1, 6, 
             "messageTypeIdentifier"));
       cde.addDataElement(new CharDE("0052", 2, "Message type version number",'O', 1, 3, 
             "messageTypeVersionNumber"));
       cde.addDataElement(new CharDE("0054", 3, "Message type release number",'O', 1, 3, 
             "messageTypeReleaseNumber"));
       cde.addDataElement(new CharDE("0051", 4, "Controlling agency",'O', 1, 2, 
             "controllingAgency"));
       cde.addDataElement(new CharDE("0057", 5, "Association assigned code",'O', 1, 6, 
             "associationAssignedCode"));
             
       returnSeg.addDataElement(new CharDE("0068", 3, "Common access reference",'O', 1, 35, 
             "commonAccessReference"));
             
       cde = new CompositeDE("S009", 4, "messageIdentifier");
       returnSeg.addCompositeDE(cde);
       cde.addDataElement(new CharDE("0070", 1, "Sequence message transfer number",'O', 1, 2, 
             "sequenceMessageTransferNumber"));
       cde.addDataElement(new CharDE("0073", 2, "First/last sequence message transfer indication",'O', 1, 1, 
             "firstLastSequenceMessageTransferIndication"));
             
       return returnSeg;
    }  
 }
