/*
 * <p>XML2Edifact.java
 * <p>Warning: this is the first test version, several settings are hardcoded.
 * <p>Copyright 1999 mendelson-e-commerce GmbH Berlin Germany
 * <p>Created on 5. Januar 2000, 15:27
 * @author Stefan Heller
 */
package de.mendelson.OBOE;

import com.americancoders.edi.*;
import java.io.*;
import java.util.*;
import org.w3c.dom.*;
import org.xml.sax.*;

public class XML2Edifact{

    public XML2Edifact() {
        this.xml2EDI( "d:/OBOE/out" );
    }
    
    /**
    * Creates classic EDI data using an XML EDI input File
    * @author S.Heller
    * @param xmlDataFileName File name of EDI XML data file
    */
    protected void xml2EDI( String xmlDataFileName ){
    int segCount; 
    TransactionSet parsedTransactionSet = null;
        try {
            org.apache.xerces.parsers.DOMParser parser 
              = new org.apache.xerces.parsers.DOMParser();
            parser.parse( new InputSource( new FileReader( xmlDataFileName )));
          
            Document document = parser.getDocument();
  			
            if (document.getNodeType() != Node.DOCUMENT_NODE) 
    		   throw new Exception("unknown node type found, should be DOCUMENT_NODE");
		
   		   if (parsedTransactionSet != null)
		      throw new Exception("document type already found");
			
            NodeList nl = document.getChildNodes();
            
            String tsName = nl.item(0).getNodeName();
             		
            String OBOEPropertiesFileName = "OBOE.properties";
            File f3, f2, f1 = new File(OBOEPropertiesFileName);
            if (f1.exists() == false)
              {
                OBOEPropertiesFileName = System.getProperty("user.home") + "/OBOE.properties";
                f2 = new File(OBOEPropertiesFileName);
                if (f2.exists() == false)
                  {
                    OBOEPropertiesFileName = System.getProperty("java.home") + "/OBOE.properties";
                    f3 = new File(OBOEPropertiesFileName);
                    if (f3.exists() == false)
                      {
                        System.err.println("Searched for OBOE.properties as " + f1.getAbsolutePath());
                        System.err.println("Searched for OBOE.properties as " + f2.getAbsolutePath());
                        System.err.println("Searched for OBOE.properties as " + f3.getAbsolutePath());
                        throw new OBOEException("OBOE.properties file not found");
                      }
                  }
              }    
            Properties properties = new Properties();
            FileInputStream inStream = new FileInputStream(OBOEPropertiesFileName);
            properties.load( inStream);
            String tsID = properties.getProperty( "rulesfile_" + tsName);
            System.out.println( "looking for XML node " 
                + tsName + " using rules file " + tsID );
            
            parsedTransactionSet = TransactionSetFactory.buildTransactionSet(tsID);
                  
	    parsedTransactionSet.parse(nl.item(0));
	    System.out.println(parsedTransactionSet.getFormattedText(0));  
          }
		  
        catch (Exception e) {
            e.printStackTrace();
        }
      }
    
        
     /**
     * @param args the command line arguments
     */
    public static void main (String args[]) {
	new XML2Edifact();
    }
    
}
