package com.americancoders.edi;

import java.util.*;

/**
 * interface for DataElement Container
 *
*<P>OBOE - Open Business Objects for EDI
 *<br>An EDI and XML Translator Written In Java 
 *<br>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
 *<br>All rights reserved
 *<br>American Coders, Ltd
 *<br>P. O. Box 97462
 *<br>Raleigh, NC  27624  USA
 *<br>1-919-846-2014
 *<br>http://www.americancoders.com
@author Joe McVerry, American Coders Ltd.
@version 1.4.1
*/

public interface IDataElementContainer
 {

/**
 * returns a DataElement in the Container
 *<br>since more than one dataelement with the same id can be
 *in the container this is not a very effective method for fetching unique datalements.
 *
 * @param String  id of the DataElement
 * @return DataElement  DataElement object
 * @exception Exception ID is unknown 
*/

public  DataElement getDataElement(String ID)
        throws Exception;

/**
 * returns a DataElement in the Container
 *
 * @param int  sequence # of the DataElement
 * @return DataElement  DataElement object
 * @exception Exception ID is unknown 
*/

public  DataElement getDataElement(int inSequence)
        throws Exception;


/**
 * sets a DataElement in the Container
 *
 * @param String  id of the DataElement
 * @return DataElement  DataElement object
 * @exception Exception ID is unknown 
*/
public void addDataElement(DataElement dataElementObject)
        throws Exception;

/**
 * returns all the data associated in a String format
 * @return String for all Dataelements 
 * @exception Exception thrown when data is missing from a data element
*/
public String get()
          throws Exception;

 }
