package com.americancoders.edi;


import java.util.*;
import com.americancoders.edi.*;

/**
 * interface for Segment Container
 *
*<P>OBOE - Open Business Objects for EDI
 *<br>An EDI and XML Translator Written In Java 
 *<br>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
 *<br>All rights reserved
 *<br>American Coders, Ltd
 *<br>P. O. Box 97462
 *<br>Raleigh, NC  27624  USA
 *<br>1-919-846-2014
 *<br>http://www.americancoders.com
@author Joe McVerry, American Coders Ltd.
@version 1.4.1
*/

public interface ITemplateSegmentContainer
 {


/**
 * returns a new Segment 
 * @param String  id of the segment
 * @return Segment objects - null indicates segment not set
 * @exception Exception ID is unknown to this Segment
*/

public Segment createSegment(String ID)
        throws Exception;


/**
 * returns a Segment 
 * @param String  id of the segment
 * @return Segment objects - null indicates segment not set
 * @exception Exception ID is unknown to this Segment
*/

public TemplateSegment getTemplateSegment(String ID)
        throws Exception;



/**
 * sets a Segment
 * <UL>
 * <li> may be used to add a new Segment
 * <li> may be used to change an existing Segment
 * <li> may be used to remove an Segment, this is done by passing a null object
 * </ul>
 * @param Segment object - null indicates segment not set
 * @exception Exception Segment is unknown 
*/

public void addTemplateSegment(TemplateSegment templateSegmentObject)
        throws Exception;


/** implemented for interface */
public int getTemplateSegmentSize();
        

 }
