package com.americancoders.edi;


import java.util.*;
import com.americancoders.edi.*;

/**
 * interface for Tokenizers
 *
*<P>OBOE - Open Business Objects for EDI
 *<br>An EDI and XML Translator Written In Java 
 *<br>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
 *<br>All rights reserved
 *<br>American Coders, Ltd
 *<br>P. O. Box 97462
 *<br>Raleigh, NC  27624  USA
 *<br>1-919-846-2014
 *<br>http://www.americancoders.com
@author Joe McVerry, American Coders Ltd.
@version 1.4.1
 */


public interface ITokenizer
    
    {
    public int countDataElements();
    public int countSegments();
    public String getCurrentDataElement();
    public int getDataElementPos();
    public String getNextDataElement();
    public IDataTokenizer getNextSegment();
    public int getSegmentPos();
    public boolean hasMoreDataElements();
    public boolean hasMoreSegments();
    public boolean isThereADataElement();
    public IDataTokenizer resetSegment();
    public IDataTokenizer makeSubfieldTokenizer();   
        
 }
        
