package com.americancoders.edi;
import javax.swing.*;
import javax.swing.text.*;
import java.io.*;

import java.awt.*;

/*
 * Copyright (C) mendelson-e-commerce GmbH Berlin Germany
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the Mozilla Public License
 * as published by the Mozilla Software Foundation
 * http://www.mozilla.org/MPL
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Mozilla Public License for more details.
 */

/** 
 * @author  S.Heller
 * @version $Revision:$
 */
public class SendEDIMailGuiPanel extends JPanel {

  protected String dataDir = ".";
  protected String host = "";
  protected String userId = "";
  protected String toWhom = "";
  
  /** Creates new panel SendEDIMailGui
  * @param host mail host
  * @param userId User Id of the sender
  */
  public SendEDIMailGuiPanel( String host, String userId ) {
    this.host = host;
    this.userId = userId;
    initComponents ();
    this.setButtonState();
  }

  /**creates new panel SendEDIMailGui with parameters*/
  public SendEDIMailGuiPanel(){
    this.initComponents();
    this.setButtonState();
    this.host = JOptionPane.showInputDialog( this, 
                                            "Please insert your message host" );
    this.userId = JOptionPane.showInputDialog( this, 
                                            "Please insert your user ID" );
  }
  
  
  /**Sets the state of the send button*/
  protected void setButtonState(){
    if( this.jTextFieldFilename.getText().length() == 0 ){
      this.jButtonSend.setEnabled( false );
      return;
    }
    
    File file = new File( this.jTextFieldFilename.getText() );
  
    this.jButtonSend.setEnabled( file.exists() && file.isFile()
                                && this.jTextFieldReceiver.getText().length() > 0 );
  }
  
  
  /**Returns the toolsbar of the GUI*/
  public JToolBar getToolBar(){
    return( this.jToolBar );
  }
  
  /**Browses the directory for a filename
   * @param parent ParentComponent of the chooser
   * @param component TextComponent where the chosen filename will displayed
   */
  public void browseFilename( Component parent, 
                              JTextComponent component ){                        
    JFileChooser chooser = new JFileChooser( this.dataDir );
    chooser.setDialogTitle( "Select EDI data to send" );
    chooser.showDialog( parent, "Select" );
    File file = chooser.getSelectedFile();
    //user pressed select button
    if( file != null )
      component.setText( file.getAbsolutePath());
  }
  
  /**sets the directory to search the edi data in*/
  public void setDataDir( String dataDir ){
    this.dataDir = dataDir;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    jPanelMain = new javax.swing.JPanel ();
    jButtonBrowseFilename = new javax.swing.JButton ();
    jTextFieldReceiver = new javax.swing.JTextField ();
    jTextFieldFilename = new javax.swing.JTextField ();
    jLabelReceiver = new javax.swing.JLabel ();
    jPanelEmpty = new javax.swing.JPanel ();
    jLabelData = new javax.swing.JLabel ();
    jToolBar = new javax.swing.JToolBar ();
    jButtonSend = new javax.swing.JButton ();
    setLayout (new java.awt.BorderLayout ());

    jPanelMain.setLayout (new java.awt.GridBagLayout ());
    java.awt.GridBagConstraints gridBagConstraints1;
    jPanelMain.setPreferredSize (new java.awt.Dimension(300, 87));
    jPanelMain.setMinimumSize (new java.awt.Dimension(300, 87));

      jButtonBrowseFilename.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/com/americancoders/edi/folder.gif")));
      jButtonBrowseFilename.setMargin (new java.awt.Insets(2, 5, 2, 5));
      jButtonBrowseFilename.setText ("Browse");
      jButtonBrowseFilename.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          jButtonBrowseFilenameActionPerformed (evt);
        }
      }
      );
  
      gridBagConstraints1 = new java.awt.GridBagConstraints ();
      gridBagConstraints1.gridx = 2;
      gridBagConstraints1.gridy = 1;
      gridBagConstraints1.insets = new java.awt.Insets (10, 0, 10, 10);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
      jPanelMain.add (jButtonBrowseFilename, gridBagConstraints1);
  
      jTextFieldReceiver.addKeyListener (new java.awt.event.KeyAdapter () {
        public void keyReleased (java.awt.event.KeyEvent evt) {
          jTextFieldReceiverKeyReleased (evt);
        }
      }
      );
  
      gridBagConstraints1 = new java.awt.GridBagConstraints ();
      gridBagConstraints1.gridx = 1;
      gridBagConstraints1.gridy = 0;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints1.insets = new java.awt.Insets (10, 10, 10, 10);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
      gridBagConstraints1.weightx = 1.0;
      jPanelMain.add (jTextFieldReceiver, gridBagConstraints1);
  
      jTextFieldFilename.addKeyListener (new java.awt.event.KeyAdapter () {
        public void keyReleased (java.awt.event.KeyEvent evt) {
          jTextFieldFilenameKeyReleased (evt);
        }
      }
      );
  
      gridBagConstraints1 = new java.awt.GridBagConstraints ();
      gridBagConstraints1.gridx = 1;
      gridBagConstraints1.gridy = 1;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints1.insets = new java.awt.Insets (15, 10, 10, 10);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
      gridBagConstraints1.weightx = 1.0;
      jPanelMain.add (jTextFieldFilename, gridBagConstraints1);
  
      jLabelReceiver.setText ("Receiver:");
  
      gridBagConstraints1 = new java.awt.GridBagConstraints ();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 0;
      gridBagConstraints1.insets = new java.awt.Insets (10, 10, 10, 10);
      jPanelMain.add (jLabelReceiver, gridBagConstraints1);
  
      jPanelEmpty.setPreferredSize (new java.awt.Dimension(0, 0));
      jPanelEmpty.setMinimumSize (new java.awt.Dimension(0, 0));
  
      gridBagConstraints1 = new java.awt.GridBagConstraints ();
      gridBagConstraints1.gridx = 1;
      gridBagConstraints1.gridy = 2;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
      gridBagConstraints1.weightx = 1.0;
      gridBagConstraints1.weighty = 1.0;
      jPanelMain.add (jPanelEmpty, gridBagConstraints1);
  
      jLabelData.setText ("EDI data:");
  
      gridBagConstraints1 = new java.awt.GridBagConstraints ();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 1;
      gridBagConstraints1.insets = new java.awt.Insets (10, 10, 10, 10);
      jPanelMain.add (jLabelData, gridBagConstraints1);
  

    add (jPanelMain, java.awt.BorderLayout.CENTER);


      jButtonSend.setIcon (new javax.swing.ImageIcon (getClass ().getResource ("/com/americancoders/edi/mail_send.gif")));
      jButtonSend.setMargin (new java.awt.Insets(2, 5, 2, 5));
      jButtonSend.setText ("Send");
      jButtonSend.addActionListener (new java.awt.event.ActionListener () {
        public void actionPerformed (java.awt.event.ActionEvent evt) {
          jButtonSendActionPerformed (evt);
        }
      }
      );
  
      jToolBar.add (jButtonSend);
  

    add (jToolBar, java.awt.BorderLayout.NORTH);

  }//GEN-END:initComponents

private void jButtonSendActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonSendActionPerformed
    String sb = null;
        byte b[] = null;
         int readi = 0;
         int reads = 0;
         FileInputStream fis = null;
        try {
         fis = new FileInputStream( this.jTextFieldFilename.getText() );
         b = new byte[(int) fis.available()];
          }
         catch (Exception e1){throw new OBOEException( e1.getMessage() );}
         try {
           while (true)
            {
             reads = fis.available();
             if (reads > 0)
                 fis.read(b, readi, reads);
             else break;
             readi += reads;
            }
           }   
         catch (IOException e1) {}
   
        sb = new String(b, 0 , readi);
        try{
          new OutgoingEDIMail( this.host, this.userId).sendEDIDocument( sb, this.toWhom, true);
        }
        catch( Exception e ){
          JOptionPane.showConfirmDialog( this, "Error", 
                                         "Error sending message:"
                                          + e.getMessage(), 
                                          JOptionPane.OK_OPTION,
                                          JOptionPane.ERROR_MESSAGE );
        }
        JOptionPane.showConfirmDialog( this, "Done", 
                                         "Message sent.",
                                         JOptionPane.OK_OPTION );
  }//GEN-LAST:event_jButtonSendActionPerformed

private void jButtonBrowseFilenameActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonBrowseFilenameActionPerformed
  this.browseFilename( this, this.jTextFieldFilename );
  this.setButtonState();
  }//GEN-LAST:event_jButtonBrowseFilenameActionPerformed

private void jTextFieldFilenameKeyReleased (java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldFilenameKeyReleased
 this.setButtonState();
  }//GEN-LAST:event_jTextFieldFilenameKeyReleased

private void jTextFieldReceiverKeyReleased (java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextFieldReceiverKeyReleased
  this.setButtonState();
  this.toWhom = this.jTextFieldReceiver.getText();
  }//GEN-LAST:event_jTextFieldReceiverKeyReleased


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel jPanelMain;
  private javax.swing.JButton jButtonBrowseFilename;
  private javax.swing.JTextField jTextFieldReceiver;
  private javax.swing.JTextField jTextFieldFilename;
  private javax.swing.JLabel jLabelReceiver;
  private javax.swing.JPanel jPanelEmpty;
  private javax.swing.JLabel jLabelData;
  private javax.swing.JToolBar jToolBar;
  private javax.swing.JButton jButtonSend;
  // End of variables declaration//GEN-END:variables

}
