package com.americancoders.edi.x12;


/**
*OBOE - Open Business Objects for EDI
*<p>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
*<p>All rights reserved
*<p>American Coders, Ltd
*<br>P. O. Box 97462
*<br>Raleigh, NC  27624  USA
*<br>1-919-846-2014
*<br>http://www.americancoders.com
 @author Joe McVerry, American Coders Ltd.
 @version 1.4.1. 
*/


import java.util.*;
import com.americancoders.edi.*;
import com.americancoders.edi.Tokenizer.*;

/**
 * factory class for Segment   Functional_Group_Header
 *
*/
public class  Functional_Group_Header 
{
    
   public static final String id = "GS";  
/** 
 * Factory method to create a Functional Group Header
 * @return Segment Functional Group Header
 * @exception Exceptions can be thrown
 */
  public static Segment getInstance()
     throws Exception
    {
       Segment returnSeg = new Segment(id, 0, "Functional Group Header", 1, 'M');
       returnSeg.addDataElement(new IDDE("479", 1,   "Functional Identifier Code", 'O', 2, 2));
       returnSeg.addDataElement(new CharDE("142", 2,  "Application Senders Code", 'O', 2, 15));
       returnSeg.addDataElement(new IDDE("124", 3,  "Application Receivers Code", 'O', 2, 15));
       returnSeg.addDataElement(new DateDE("373", 4, "Date", 'O', 6, 6));
       returnSeg.addDataElement(new TimeDE("337", 5, "Time", 'O', 4, 8));
       returnSeg.addDataElement(new NumericDE("I12", 6, "N0", "Group Control Number", 'O', 9, 9));
       returnSeg.addDataElement(new IDDE("455", 7,  "Responsible Agency Code", 'O', 1, 2));
       returnSeg.addDataElement(new CharDE("480", 8, "Version Release Industry Id Code", 'O', 1, 12));
       
       return returnSeg;
    }
}   
