package com.americancoders.edi.x12;

/**
 *OBOE - Open Business Objects for EDI 
 *<p>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
 *<p>All rights reserved
 *<p>American Coders, Ltd
 *<br>P. O. Box 97462
 *<br>Raleigh, NC  27624  USA
 *<br>1-919-846-2014
 *<br>http://www.americancoders.com
@author Joe McVerry, American Coders Ltd.
@version 1.4.1
*/


import java.util.*;
import com.americancoders.edi.*;
import com.americancoders.edi.Tokenizer.*;

/**
 * staticly defined class for x12 Segment   Functional_Group_Trailer
 *
*/
public class  Functional_Group_Trailer 
 {
    
  public static final String id = "GE";  
   
 /** 
 * Factory method to create a Functional Group Trailer
 * @return Segment Functional Group Trailer
 * @exception Exceptions can be thrown
 */
 public static Segment getInstance()
     throws Exception
    {
       Segment returnSeg = new Segment(id, 0, "Functional Group Trailer", 1, 'M');
       returnSeg.addDataElement(new NumericDE("79", 1, "N0", "Number of Included Sets", 'O', 1, 6));
       returnSeg.addDataElement(new NumericDE("I12", 2, "N0", "Group Control Number", 'O', 9, 9));
       return returnSeg;
    }
    
 }   
    
