package com.americancoders.edi.x12;

/**
 *OBOE - Open Business Objects for EDI 
 *<p>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
 *<p>All rights reserved
 *<p>American Coders, Ltd
 *<br>P. O. Box 97462
 *<br>Raleigh, NC  27624  USA
 *<br>1-919-846-2014
 *<br>http://www.americancoders.com
@author Joe McVerry, American Coders Ltd.
@version 1.4.1
*/


import java.util.*;
import com.americancoders.edi.*;
import com.americancoders.edi.Tokenizer.*;

/**
 * staticly defined class for x12 Segment   Interchange_Control_Header
 *
*/
public class  Interchange_Control_Header
 {
    
  public static final String id = "ISA";
  
/** 
 * Factory method to create an Interchange Control Header
 * @return Segment Interchange Control Header
 * @exception Exceptions can be thrown
 */

  public static Segment getInstance()
     throws Exception
    {
       Segment returnSeg = new Segment(id, 0, "Interchange Control Header", 1, 'M');
       returnSeg.addDataElement(new IDDE("I01", 1, "Authorization Information Qualifier", 'O', 2, 2));
       returnSeg.addDataElement(new CharDE("I02", 2,  "Authorization Information", 'O', 10, 10));
       returnSeg.addDataElement(new IDDE("I03", 3, "Security Inform Qualifier", 'O', 2, 2));
       returnSeg.addDataElement(new CharDE("I04", 4, "Security Information", 'O', 10, 10));
       returnSeg.addDataElement(new IDDE("I05", 5, "Interchange ID Qualifier", 'O', 2, 2));
       returnSeg.addDataElement(new CharDE("I06", 6, "Interchange Sender ID", 'O', 15, 15));
       returnSeg.addDataElement(new IDDE("I05", 7, "Interchange ID Qualifier", 'O', 2, 2));
       returnSeg.addDataElement(new CharDE("I07", 8,  "Interchange Receiver ID", 'O', 15, 15));
       returnSeg.addDataElement(new DateDE("I08", 9, "Interchange Date", 'O', 6, 6));
       returnSeg.addDataElement(new TimeDE("I09",10, "Interchange Time", 'O', 4, 4));
       returnSeg.addDataElement(new IDDE("I10", 11, "Interchange Control Standards ID", 'O', 1, 1));
       returnSeg.addDataElement(new CharDE("I11", 12, "Interchange Control Version Number", 'O', 5, 5));
       returnSeg.addDataElement(new NumericDE("I12", 13, "N0", "Interchange Control Number", 'O', 9, 9));
       returnSeg.addDataElement(new IDDE("I13", 14, "Acknowledgment Requested", 'O', 1, 1));
       returnSeg.addDataElement(new IDDE("I14", 15, "Test Indicator", 'O', 1, 1));
       returnSeg.addDataElement(new CharDE("I15", 16, "Subelement Separator", 'O', 1, 1));
       return returnSeg;
    }  
 }
