package com.americancoders.edi.x12;


/**
*OBOE - Open Business Objects for EDI
*<p>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
*<p>All rights reserved
*<p>American Coders, Ltd
*<br>P. O. Box 97462
*<br>Raleigh, NC  27624  USA
*<br>1-919-846-2014
*<br>http://www.americancoders.com
 @author Joe McVerry, American Coders Ltd.
 @version 1.4.1. 
*/


import java.util.*;
import com.americancoders.edi.*;
import com.americancoders.edi.Tokenizer.*;

/**
 * factory class for Segment  Interchange_Delivery_Notice
 *
*/
public class Interchange_Delivery_Notice
{
    
   public static final String id = "TA3";  
/** 
 * Factory method to create a Interchange Delivery Notice
 * @return Segment Interchange Delivery Notice
 * @exception Exceptions can be thrown
 */
  public static Segment getInstance()
     throws Exception
    {
       Segment returnSeg = new Segment(id, 0, "Interchange Delivery Notice", 1, 'M');
       returnSeg.addDataElement(new IDDE("I38", 1, "Service Request Handler ID Qualifier", 'M', 2, 2));
       returnSeg.addDataElement(new CharDE("I39", 2, "Service Request Handler ID", 'M', 1, 15));
       returnSeg.addDataElement(new IDDE("I43", 3, "Error Reason Code", 'M', 3, 3));
       returnSeg.addDataElement(new CharDE("I44", 4, "Reported Start Segment ID", 'M', 2, 3));
       returnSeg.addDataElement(new CharDE("I45", 5, "Reported Control Number", 'M', 1, 14));
       returnSeg.addDataElement(new DateDE("I46", 6, "Reported Date", 'M', 1, 8));
       returnSeg.addDataElement(new CharDE("I47", 7, "Reported Time", 'M', 1, 8));
       returnSeg.addDataElement(new CharDE("I48", 8, "Reported Interchange Sender ID Qualifier", 'M', 1, 4));
       returnSeg.addDataElement(new CharDE("I49", 9, "Reported Sender ID", 'M', 1, 35));
       returnSeg.addDataElement(new CharDE("I50", 10, "Reported Interchange Receiver ID Qualifier", 'M', 1, 4));
       returnSeg.addDataElement(new IDDE("I51", 11, "Reported Receiver", 'M', 1, 35));
       returnSeg.addDataElement(new IDDE("I40", 12, "Action Code", 'M', 2, 2));
       returnSeg.addDataElement(new DateDE("I41", 13, "Action Date", 'M', 6, 8));
       returnSeg.addDataElement(new TimeDE("I42", 14, "Action Time", 'M', 4, 4));
       returnSeg.addDataElement(new IDDE("I40", 15, "Action Code", 'M', 2, 2));
       returnSeg.addDataElement(new DateDE("I41", 16, "Action Date", 'M', 6, 8));
       returnSeg.addDataElement(new IDDE("I42", 17, "Action Time", 'M', 4, 4));
       returnSeg.addDataElement(new CharDE("I52", 18, "First Reference ID Qualifier", 'O', 1, 4));
       returnSeg.addDataElement(new CharDE("I53", 19, "First Reference ID", 'O', 1, 14));
       returnSeg.addDataElement(new CharDE("I54", 20, "Second Reference ID Qualifier", 'O', 1, 14));
       returnSeg.addDataElement(new CharDE("I55", 21, "Second Reference ID", 'O', 1, 14));
       returnSeg.addDataElement(new IDDE("I56", 22, "Reference Code Qualifier", 'X', 2, 2));
       returnSeg.addDataElement(new CharDE("I57", 23, "Reference Code", 'X', 1, 35));
       returnSeg.addDataElement(new IDDE("I56", 24, "Reference Code Qualifier", 'X', 2, 2));
       returnSeg.addDataElement(new CharDE("I57", 25, "Reference Code", 'X', 1, 35));
       returnSeg.addDataElement(new IDDE("I56", 26, "Reference Code Qualifier", 'X', 2, 2));
       returnSeg.addDataElement(new CharDE("I57", 27, "Reference Code", 'X', 1, 35));
       
       return returnSeg;
    }
}   



