package com.americancoders.edi;
/**
 *OBOE - Open Business Objects for EDI
 *<P>An EDI and XML Translator Written In Java 
 *<p>Copyright 1998-2000 - American Coders, LTD  - Raleigh NC USA
 *<p>All rights reserved
 *<p>American Coders, Ltd
 *<br>P. O. Box 97462
 *<br>Raleigh, NC  27624  USA
 *<br>1-919-846-2014
 *<br>http://www.americancoders.com
@author Joe McVerry, American Coders Ltd.
@version 1.4.1
*/
import java.io.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import com.americancoders.edi.x12.Parser;

class viewEDIObjects extends Frame
      implements ActionListener, WindowListener, ComponentListener

{
  Panel p;
  GridBagLayout gb;
  GridBagConstraints gbc;
  TextArea text;
  Button done, save;
  TransactionSet ts;
  
  public viewEDIObjects(String arg)
    {
        super("view EDI Objects in " + arg);
        try {
            File f = new File(arg);
            Parser p = new Parser(f);
            ts = p.getTransactionSet();
            }
         catch (Exception e1) {
            System.out.println(e1.getMessage());
            e1.printStackTrace();
            System.exit(1);
            }
         setLayout(null);
         removeAll();
         addWindowListener(this);
         addComponentListener(this);
         gb = new GridBagLayout();
         gbc = new  GridBagConstraints();
         setLayout(gb);
         text = new TextArea();
//         try {text.setText(ts.getFormattedText(1));}
         try {text.setText(ts.get());}
         catch (Exception e2) {
            text.setText(e2.getMessage());
            e2.printStackTrace();
         }
         done = new Button("Quit");
         done.addActionListener(this);
         save = new Button("Save");
         save.addActionListener(this);
         try {
            addComponent(this, done, 0, 0, 10, 20, GridBagConstraints.HORIZONTAL, GridBagConstraints.EAST);
            addComponent(this, save, 10, 0, 10, 20, GridBagConstraints.HORIZONTAL, GridBagConstraints.EAST);
            addComponent(this, text, 0, 20, 450,450,  GridBagConstraints.BOTH, GridBagConstraints.CENTER);
            }
         catch (Exception e1)
           {
             System.out.println(e1.getMessage());
             System.exit(2);
           }
           
         pack();
         show();
    }

    public void windowClosing(WindowEvent event) {
           setVisible(false);
           dispose();
           //System.exit(0);
           }
  

    public void windowClosed(WindowEvent event) {
         }

    public void windowDeiconified(WindowEvent event) {
         }

    public void windowIconified(WindowEvent event) {
         }

    public void windowActivated(WindowEvent event) {
         }

    public void windowDeactivated(WindowEvent event) {
         }

    public void windowOpened(WindowEvent event) {
         }

    public void componentHidden(ComponentEvent Event) {}

    public void componentMoved(ComponentEvent Event) {}

    public void componentShown(ComponentEvent Event) {}

    public void componentResized(ComponentEvent Event) {}

    public void actionPerformed(ActionEvent event)
    throws RuntimeException
    {
        if (event.getSource() == done) {
             setVisible(false);
             dispose();
             //System.exit(0);
             return;
             }
        if (event.getSource() == save) {
             FileDialog fd = new FileDialog(this, "Saving EDI Text File", FileDialog.SAVE);
             fd.setFile("*.txt");
             fd.pack();
             fd.show();
             String fname = fd.getFile();
             String dname = fd.getDirectory();

            if (fname == null) 
                return;
            if (fname.length() < 1) 
                   return;

            String  txtfname = new String(dname + fname);
            try{
               FileOutputStream fos = new FileOutputStream(txtfname);
               fos.write(text.getText().getBytes());
               fos.flush();
               fos.close();
               }
            catch (Exception e1) {
               System.out.println(e1.getMessage());
               e1.printStackTrace();
               //throw e1;
               }
          }
    }

public static void addComponent (Container container, Component component,
    int gridx, int gridy, int gridwidth, int gridheight, int fill,
    int anchor) throws AWTException {
    LayoutManager lm = container.getLayout();
    if (!(lm instanceof GridBagLayout)) {
        throw new AWTException ("Invalid layout: " + lm);
    } else {
        GridBagConstraints gbc = new GridBagConstraints ();
        gbc.gridx = gridx;
        gbc.gridy = gridy;
        gbc.gridwidth = gridwidth;
        gbc.gridheight = gridheight;
        gbc.fill = fill;
        gbc.anchor = anchor;
        ((GridBagLayout)lm).setConstraints(component, gbc);
        container.add (component);
    }
}
  public static void main(String argv[])
     {
         viewEDIObjects f = new viewEDIObjects(argv[0]);       
     }
}
